<?php
///////////////////////////////////////////////////////////////////////////////////
//                                                                               //
// BLNews -- Copyright (c) 2001 by Florian Sperber                               //
//             webmaster@blnews.de                                               //
//                                                                               //
//    This program is free software; you can redistribute it and/or modify       //
//    it under the terms of the GNU General Public License as published by       //
//    the Free Software Foundation; either version 2 of the License, or          //
//    (at your option) any later version.                                        //
//                                                                               //
//    This program is distributed in the hope that it will be useful,            //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of             //
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              //
//    GNU General Public License for more details.                               //
//                                                                               //
//    You should have received a copy of the GNU General Public License          //
//    along with this program; if not, write to the Free Software                //
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  //
//                                                                               //
///////////////////////////////////////////////////////////////////////////////////

 include ("users.inc.php4");
?>
<html>
<head>
 <title><?php echo "$sprachinhalt[title_userman]";?></title>
</head>
<body>

<?php

 
 
 $c=$User;

function ShowUsers()
{
 global $PHP_SELF, $sprachinhalt, $c;
 $us=$c->GetUsers();
 echo "
 <table style=\"border: 1px solid #000099\">
  <tr>
   <td><b>$sprachinhalt[UID]</b></td>
   <td><b>$sprachinhalt[Username]</b></td>
   <td><b>$sprachinhalt[realname]</b></td>
   <td><b>$sprachinhalt[50]</b></td>
  </tr>
 ";
 foreach ($us as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  echo "
   <tr>
    <td>$uinfo[Idx]</td>
	<td>$uinfo[username]</td>
    <td>$uinfo[Realname]</td>
    <td>$uinfo[email]</td>
	<td><a href=\"$PHP_SELF?mymenu=12&uid=$uinfo[Idx]\">$sprachinhalt[bearbeiten]</a></td>
	<td><a href=\"$PHP_SELF?mymenu=13&uid=$uinfo[Idx]\">$sprachinhalt[loeschen]</a></td>
   </tr>
   ";
 
 }
 echo "</table>";
}
function NewUser()
{
 global $PHP_SELF, $sprachinhalt, $c, $mymenu, $submit, $username, $realname, 
        $email, $description, $pass;
 
 if (!isset($submit))
 {

  $F=new FormWriter($PHP_SELF,"","$sprachinhalt[submit]");
  $F->AddLine("<input type=text name=\"username\" value=\"$username\">","$sprachinhalt[Username]*:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"realname\" value=\"$realname\">","$sprachinhalt[realname]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"email\" value=\"$email\">","$sprachinhalt[email_adress]*:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"description\" value=\"$description\">","$sprachinhalt[description]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"pass\" value=\"$pass\">","$sprachinhalt[password]*:","#ff3300","","#3399ff","");
  $F->AddHidden("<input type=hidden name=\"mymenu\" value=\"$mymenu\">");

 echo $F->DrawForm();
 echo "$sprachinhalt[verpflichtend].";
 
 }
 else
 { // Formular wurde abgeschickt
  $erg=$c->AddUser($username,$realname,$pass,$email,$description);
  if ($erg<=0)
  {
   echo "$sprachinhalt[could_not_create_user]";
   echo "<a href=\"$PHP_SELF\">$sprachinhalt[weiter]</a>";
  }
  else
  {
   echo "$sprachinhalt[54]";
   echo "<a href=\"$PHP_SELF\">$sprachinhalt[weiter]</a>";
  }
 }
}

function ShowOverview()
{
 global $PHP_SELF, $sprachinhalt, $c, $sel,$suser;
 
 
 
 $groups=$c->GetGroups();
 $us=$c->GetUsers();

 echo "
 <table border=1>
  <tr>
   <td valign=top>
  "; 
  echo "<img src=\"img/ltop.gif\">";
  echo " <b><a href=\"$PHP_SELF?sel=-1\">Alle User</a></b><br>\n";
  $us=$c->GetUsers();
  if ($sel=="-1")
  {
   foreach ($us as $cur)
   {
    $uinfo=$c->GetUserInfo($cur);
    echo "<img src=\"img/lrechts.gif\">";
    echo "<img src=\"img/lhoriz.gif\">";
    echo " <a href=\"$PHP_SELF?sel=-1&suser=$cur\">$uinfo[username]</a><br>\n";
   }
  }
 foreach ($groups as $value)
 {
  $ginfo=$c->GetGroupInfo($value);
  echo "<img src=\"img/lpunkt.gif\">";
  echo " <b><a href=\"$PHP_SELF?sel=$value\">$ginfo[name]</a></b><br>\n";
  $members=$c->GetGroupMembers($value);
  if ($sel=="$value")
  {
   foreach ($members as $u)
   {
    $uinfo=$c->GetUserInfo($u);
    echo "<img src=\"img/lrechts.gif\">";
	echo "<img src=\"img/lhoriz.gif\">";
    echo " <a href=\"$PHP_SELF?sel=$value&suser=$u\">$uinfo[username]</a>";
     if ($c->IsModerator($value,$u)) {   echo "<img src=\"img/mod.gif\" alt=\"Moderator\">";}
     echo "<br>\n";
   }
  }
 }
 echo"
    </td>
	<td valign=top>
 ";
 if ($sel=="-1" and !isset($suser))
 {
  echo "<a href=\"$PHP_SELF?mymenu=21\">Neue Gruppe anlegen</a><br>\n";
  echo "<a href=\"$PHP_SELF?mymenu=11\">Neuen User anlegen</a><br>\n";
 }
 if (isset($sel) and !isset($suser) and ($sel>=0))
 {
  $ginfo=$c->GetGroupInfo($sel);
  ShowGroupDetail($sel);
 }
 if (isset($suser))
 {
  $uinfo=$c->GetUserInfo($suser);
  echo "
    <table border=0>
	 <tr>
	  <td><b>Username:</b></td>
	  <td>$uinfo[username] ($uinfo[Idx])</td>
	 </tr>
	 <tr>
	  <td><b>Realname:</b></td>
	  <td>$uinfo[Realname]</td>
	 </tr>
	 <tr>
	  <td><b>E-Mail-Adresse:</b></td>
	  <td>$uinfo[email]</td>
	 </tr>
	 <tr>
	  <td><b>Kommentar:</b></td>
	  <td>$uinfo[description]</td>
	 </tr>
	 
	 <tr>
	  <td colspan=2></td>
	 </tr>
	 <tr>
	  <td colspan=2><a href=\"$PHP_SELF?mymenu=12&uid=$uinfo[Idx]\">$sprachinhalt[90]</a></td>
	 </tr>
	 <tr>
	  <td colspan=2><a href=\"$PHP_SELF?mymenu=13&uid=$uinfo[Idx]\">$sprachinhalt[89]</a></td>
	 </tr>
	</table>
  ";
 }
 echo "
	</td>
  </tr>
 </table>
 ";
 
}

function EditUser()
{
 global $PHP_SELF, $c, $sprachinhalt, $mymenu, $submit, $username, $realname, 
        $email, $description, $pass, $uid;

 if (!isset($submit))
 {
  $uinfo=$c->GetUserInfo($uid);

  $F=new FormWriter($PHP_SELF,"","$sprachinhalt[submit]");
  
  $F->AddLine("<input type=text name=\"username\" value=\"$uinfo[username]\">","$sprachinhalt[Username]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"realname\" value=\"$uinfo[Realname]\">","$sprachinhalt[realname]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"email\" value=\"$uinfo[email]\">","$sprachinhalt[email_adress]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"description\" value=\"$uinfo[kommentar]\">","$sprachinhalt[Beschreibung]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"pass\" value=\"\">","$sprachinhalt[48]:","#ff3300","","#3399ff","");
  $F->AddHidden("<input type=hidden name=\"mymenu\" value=\"$mymenu\">");
  $F->AddHidden("<input type=hidden name=\"uid\" value=\"$uid\">");

 echo $F->DrawForm();
 echo "&nbsp;&nbsp;&nbsp;<a href=\"$PHP_SELF\"><b>$sprachinhalt[zurueck]</b></a>";
 }
 else
 {
  $erg=$c->UpdateUser($uid,$username,$realname,$pass,$email,$description);
  if ($erg)
  {
   echo "$sprachinhalt[55] $erg"; //erfolgreich gendert UID ist.
   echo "<a href=\"$PHP_SELF\">$sprachinhalt[weiter]</a>";
  }
  else
  {
   echo "$sprachinhalt[could_not_edit_user]<br>";
   echo "<a href=\"$PHP_SELF\">$sprachinhalt[weiter]</a>";
  }
 }
}


function DeleteUser()
{
 global $PHP_SELF, $sprachinhalt, $c,$uid,$mymenu,$yes;
 
 if (!isset($yes))
 {
  $uinfo= $c->GetUserInfo($uid);
  echo "$sprachinhalt[56] <b>$uinfo[username]</b> ($uid) $sprachinhalt[57]<br>";
  echo "<a href=\"$PHP_SELF?mymenu=$mymenu&uid=$uid&yes=1\">$sprachinhalt[Ja]</a>&nbsp;&nbsp;&nbsp;&nbsp;";
  echo "&nbsp;&nbsp;&nbsp;<a href=\"$PHP_SELF\"><b>$sprachinhalt[zurueck]</b></a>";
 }
 else
 {
  $erg=$c->DeleteUser($uid);
  if ($erg==-1)
  {
   echo "$sprachinhalt[58] ($uid)<br>";
  }
  else
  {
   echo "$sprachinhalt[59] ($uid)<br>";
  }
 echo "<a href=\"$PHP_SELF\"><b>$sprachinfo[weiter]</b></a>";   
 }
 
}
function ShowGroups()
{
 global $PHP_SELF, $sprachinhalt, $c;
 
 $groups=$c->GetGroups();
 echo "<table style=\"border: 1px solid #000099\">";
 foreach ($groups as $value)
 {
  echo "<tr>";
  $ginfo=$c->GetGroupInfo($value);
  echo "
   <td>$ginfo[Idx]</td>
   <td>$ginfo[name]</td>
   <td>$ginfo[description]</td>

   <td><a href=\"$PHP_SELF?mymenu=25&gid=$ginfo[Idx]\">$sprachinhalt[Details]</a></td>   
  </tr>";
 }
 echo "</table>";
 
}
function NewGroup()
{
 global $PHP_SELF, $sprachinhalt, $c, $mymenu, $submit, $groupname, $description;
 
 if (!isset($submit))
 {
  $F=new FormWriter($PHP_SELF,"","$sprachinhalt[submit]");
  $F->AddLine("<input type=text name=\"groupname\" value=\"$groupname\">","$sprachinhalt[groupname]:","#ff3300","","#3399ff","");
  $F->AddLine("<input type=text name=\"description\" value=\"$description\">","$sprachinhalt[Beschreibung]:","#ff3300","","#3399ff","");
  $F->AddHidden("<input type=hidden name=\"mymenu\" value=\"$mymenu\">");
  echo $F->DrawForm();
 }
 else
 { // Formular wurde abgeschickt
  $erg=$c->AddGroup($groupname,$description);
  if ($erg<=0)
  {
   echo "$sprachinhalt[60] ($erg)";
  }
  else
  {
   echo "$sprachinhalt[61] $erg";
   echo "<a href=\"$PHP_SELF\">$sprachinhalt[weiter]</a>";
  }
 }
}
function EditGroup()
{
 global $PHP_SELF, $Server,$c,$gid;
 echo "Noch nicht implementiert, sorry.";
 echo "<a href=\"$PHP_SELF?sel=$gid\">$sprachinhalt[weiter]</a>";
}
function DeleteGroup()
{
 global $PHP_SELF, $sprachinhalt, $c, $gid, $mymenu, $yes;
 
 if (!isset($yes))
 {
  $uinfo= $c->GetGroupInfo($gid);
  echo " $sprachinhalt[62] <b>$uinfo[name]</b> ($gid) $sprachinhalt[63]<br>";
  echo "<a href=\"$PHP_SELF?mymenu=$mymenu&gid=$gid&yes=1\">$sprachinhalt[Ja]</a>&nbsp;&nbsp;&nbsp;&nbsp;";
  echo "&nbsp;&nbsp;&nbsp;<a href=\"$PHP_SELF?sel=$gid\"><b>[zurueck]</b></a>";
 }
 else
 {
  $erg=$c->DeleteGroup($gid);
  if ($erg==-1)
  {
   echo "$sprachinhalt[64] ($gid)<br>";
  }
  else
  {
   echo "$sprachinhalt[65] ($gid)<br>";
  }
 echo "<a href=\"$PHP_SELF\"><b>$sprachinhalt[weiter]</b></a>";   
 }
}
function ManageMembers()
{
 global $PHP_SELF, $sprachinhalt, $mymenu, $c, $gid, $uid, $action;
 
 // Fr den Anfang generiere ich nur eine liste mit verschiedenen links
 if ($action=="add")
 {
  $erg=$c->AddMember($gid,$uid);
  if ($erg===false) { echo "<font color=\"Red\">$sprachinhalt[66]</font>";}
 }
 if ($action=="remove")
 {
  $erg=$c->RemoveMember($gid,$uid);
  if ($erg===false) { echo "<font color=\"Red\">$sprachinhalt[67]</font>";}
 }
 
 
 // Ausgabe der Listen
 $ginfo=$c->GetGroupInfo($gid);
 echo "<h2>$sprachinhalt[68]</h2>";
 echo "$sprachinhalt[Gruppe]: <b>$ginfo[name]</b> ($ginfo[Idx])<P>";
 echo "<a href=\"$PHP_SELF?sel=$gid\"><b>$sprachinhalt[zurueck]</b></a>"; 
 echo "<table style=\"border: 1px solid #000099\">
  <tr>
   <td><b>$sprachinhalt[69]</b></td>
   <td><b>$sprachinhalt[70]</b></td>
  </tr>
  <tr>
   <td style=\"border: 1px solid Blue\">
  ";
 $m=$c->GetGroupMembers($gid);
 foreach($m as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  if ($cur=="")
  {} else
  {
  echo "<a href=\"$PHP_SELF?mymenu=$mymenu&gid=$gid&uid=$uinfo[Idx]&action=remove\">$uinfo[username]($uinfo[Idx])</a> -><br>";}
 } 
 echo "
  </td>
  <td style=\"border: 1px solid Blue\">
 ";
 $u=$c->GetUsers();
 foreach ($u as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  if (in_array($cur,$m))
  { } else 
  {
   echo "<- <a href=\"$PHP_SELF?mymenu=$mymenu&gid=$gid&uid=$uinfo[Idx]&action=add\">$uinfo[username]($uinfo[Idx])</a><br>";
  }
 } 
echo "  
  </td>
  </tr>
 </table>
 ";
 echo "<a href=\"$PHP_SELF?sel=$gid\"><b>$sprachinhalt[zurueck]</b></a>"; 
}

function ManageModerator()
{
 global $PHP_SELF, $sprachinhalt, $mymenu, $c, $gid, $uid, $action;
 
 // Fr den Anfang generiere ich nur eine liste mit verschiedenen links
 if ($action=="add")
 {
  $erg=$c->AddModerator($gid,$uid);
  if ($erg===false) { echo "<font color=\"Red\">$sprachinhalt[71]</font>";}//AddModerator failed
 }
 if ($action=="remove")
 {
  $erg=$c->RemoveModerator($gid,$uid);
  if ($erg===false) { echo "<font color=\"Red\">$sprachinhalt[72]</font>";}//removemember failed
 }
 
 
 // Ausgabe der Listen
 $ginfo=$c->GetGroupInfo($gid);
 echo "<h2>$sprachinhalt[73]</h2>";
 echo "$sprachinhalt[Gruppe]: <b>$ginfo[name]</b> ($ginfo[Idx])<P>";
 echo "<a href=\"$PHP_SELF?sel=$gid\"><b>$sprachinhalt[zurueck]</b></a>"; 
 // Ist Moderator, Ist kein Moderator
 echo "<table style=\"border: 1px solid #000099\">
  <tr>
   <td><b>$sprachinhalt[74]</b></td>
   <td><b>$sprachinhalt[75]</b></td>
  </tr>
  <tr>
   <td style=\"border: 1px solid Blue\">
  ";
 $m=$c->GetGroupModerator($gid);
 foreach($m as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  if ($cur=="")
  {} else
  {
  echo "<a href=\"$PHP_SELF?mymenu=$mymenu&gid=$gid&uid=$uinfo[Idx]&action=remove\">$uinfo[username]($uinfo[Idx])</a> -><br>";}
 } 
 echo "
  </td>
  <td style=\"border: 1px solid Blue\">
 ";
 $u=$c->GetUsers();
 foreach ($u as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  if (in_array($cur,$m))
  { } else 
  {
   echo "<- <a href=\"$PHP_SELF?mymenu=$mymenu&gid=$gid&uid=$uinfo[Idx]&action=add\">$uinfo[username]($uinfo[Idx])</a><br>";
  }
 } 
echo "  
  </td>
  </tr>
 </table>
 ";
 echo "<a href=\"$PHP_SELF?sel=$gid\"><b>$sprachinhalt[zurueck]</b></a>"; 
}

function ShowGroupDetail($rgid="")
{
 global $PHP_SELF, $sprachinhalt, $c, $gid;
 if ($rgid!="") {$gid=$rgid;}
 $erg=$c->GetGroupInfo($gid);
 $m=$c->GetGroupMembers($gid);
 $cou=0;$tmember="";
 foreach($m as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  if ($cou>0)  { $tmember .=", ";}
  $tmember .="$uinfo[username]($uinfo[Idx])";
  $cou++;
 } 
 $m=$c->GetGroupModerator($gid);
 $cou=0;$tmoderator="";
 foreach($m as $cur)
 {
  $uinfo=$c->GetUserInfo($cur);
  if ($cou>0)  { $tmoderator .=", ";}
  $tmoderator .="$uinfo[username]($uinfo[Idx])";
  $cou++;
 } 
 if ($erg[approve]==1) { $approve="$sprachinhalt[76]";} // approve ist aktiviert
  else { $approve="$sprachinhalt[77]";} //approve ist nicht aktiviert

 echo "
  <table border=0>
   <tr>
    <td>$sprachinhalt[78]:</td>
	<td>$erg[Idx]</td>
	<td></td>
   </tr>
   <tr>
    <td>$sprachinhalt[79]:</td>
	<td>$erg[name]</td>
	<td></td>
   </tr>
   <tr>
    <td>$sprachinhalt[80]:</td>
	<td>$erg[description]</td>
	<td></td>
   </tr>
   <tr>
    <td>$sprachinhalt[81]:</td>
	<td>$tmember</td>
	<td><a href=\"$PHP_SELF?mymenu=24&gid=$gid\">$sprachinhalt[84]</a></td>
   </tr>
   <tr>
    <td>$sprachinhalt[82]:</td>
	<td>$tmoderator</td>
	<td><a href=\"$PHP_SELF?mymenu=26&gid=$gid\">$sprachinhalt[85]</a></td>
   </tr>
   <tr>
    <td>$sprachinhalt[83]:</td>
	<td>$approve</td>
	<td><a href=\"$PHP_SELF?mymenu=27&gid=$gid\">$sprachinhalt[86]</a></td>
   </tr>
  	<tr>
	 <td colspan=2><br><center>
	    <a href=\"$PHP_SELF?mymenu=22&gid=$gid\">$sprachinhalt[87]</a><br>
   <a href=\"$PHP_SELF?mymenu=23&gid=$gid\">$sprachinhalt[88]</a></center>
     </td>
	 <td></td>
	</tr>
  </table>";

}

function ApproveGroup()
{
 global $PHP_SELF, $c, $gid;
 if ($c->ApproveGroup($gid)===false)
 { echo "FEHLER!!!!<br>";}
 echo "<a href=\"$PHP_SELF?sel=$gid\">Weiter</a>";
}



function ShowWelcome()
{
 echo "Willkommen beim User/Group-Manager<P>\n";
 ShowOverView();
} 

if ($User->IsAllowed($Main_UserID,"0"))
{
 echo "
  <table border=0>
   <tr>
    <td valign=top>
 ";
 $Men = new TMenu();
 $Men->AddEntry("User anzeigen",1,1);
 $Men->AddEntry("&nbsp;&nbsp;Neuen User anlegen",1,11);
 $Men->AddEntry("Gruppen anzeigen",1,2);
 $Men->AddEntry("&nbsp;&nbsp;Neue Gruppe anlegen",1,21);
 $Men->AddEntry("Zur&uuml;ck",1,-1); 

 $Men->DrawMenu();

 echo "   
    </td>
    <td valign=top>
 ";

 switch ($mymenu)
 {
   case "1" : ShowUsers(); break;
   case "11" : NewUser(); break;
   case "12" : EditUser(); break;
   case "13" : DeleteUser(); break;
   case "2" : ShowGroups(); break;
   case "21" : NewGroup(); break;
   case "22" : EditGroup(); break;
   case "23" : DeleteGroup(); break;
   case "24" : ManageMembers(); break;
   case "25" : ShowGroupDetail(); break;
   case "26" : ManageModerator(); break;  
   case "27" : ApproveGroup(); break;
 
   default: ShowWelcome();
 }
 echo "   
    </td>
   </tr>
 </table>";

}
else
{
 echo "You don't have permission to access this area.";
 
} 
 
 
?>



</body>
</html>
